%global momorel 7
%global geckover 1.9.1

%global eclipse_version    3.4.2
%global pleiades_version   1.3.0
%global relnum             200902111700
%global pleiades_relnum    38225

%ifarch %{ix86}
%define targetarch x86
%else
%ifarch x86_64
%define targetarch x86_64
%endif
%endif

%global eclipse_dir %{_libdir}/%{name}

Summary: Eclipse Integrated Development Environment
Name: eclipse
Version: %{eclipse_version}
Release: %{momorel}m%{?dist}
License: "Eclipse Public License"
Group: Development/Tools
URL: http://www.eclipse.org/
Source0: ftp://ftp.jaist.ac.jp:/pub/eclipse/eclipse/downloads/drops/R-%{eclipse_version}-%{relnum}/eclipse-sourceBuild-srcIncluded-%{eclipse_version}.zip
NoSource: 0
Source1: http://iij.dl.sourceforge.jp/mergedoc/%{pleiades_relnum}/pleiades_%{pleiades_version}.zip
NoSource: 1
Source1000: eclipse.sh.in
Source1001: eclipserc.in
Source1002: eclipse.desktop
Patch0: eclipse-osgi-classpath.patch
Patch10: eclipse-swt-buildagainstxulrunner.patch
Patch11: eclipse-swt-xulrunner191.patch
ExclusiveArch: %{ix86} x86_64
BuildRequires: coreutils tar unzip
BuildRequires: ant >= 1.6.1
BuildRequires: java-devel >= 1.6.0
BuildRequires: GConf2-devel
BuildRequires: ORBit2-devel
BuildRequires: alsa-lib-devel
BuildRequires: atk-devel
BuildRequires: audiofile-devel
BuildRequires: avahi-devel
BuildRequires: avahi-glib-devel
BuildRequires: cairo-devel
BuildRequires: dbus-devel
BuildRequires: dbus-glib-devel
BuildRequires: e2fsprogs-devel
BuildRequires: esound-devel
BuildRequires: expat-devel
BuildRequires: fontconfig-devel
BuildRequires: freetype-devel
BuildRequires: glib2-devel
BuildRequires: glibc-devel
BuildRequires: glitz-devel
BuildRequires: gnome-keyring-devel
BuildRequires: gnome-vfs2-devel
BuildRequires: gtk2-devel
BuildRequires: keyutils-libs-devel
BuildRequires: krb5-devel
BuildRequires: lcms-devel
BuildRequires: libICE-devel
BuildRequires: libSM-devel
BuildRequires: libX11-devel
BuildRequires: libXau-devel
BuildRequires: libXcomposite-devel
BuildRequires: libXcursor-devel
BuildRequires: libXdamage-devel
BuildRequires: libXdmcp-devel
BuildRequires: libXext-devel
BuildRequires: libXfixes-devel
BuildRequires: libXft-devel
BuildRequires: libXi-devel
BuildRequires: libXinerama-devel
BuildRequires: libXrandr-devel
BuildRequires: libXrender-devel
BuildRequires: libXt-devel
BuildRequires: libXtst-devel
BuildRequires: libart_lgpl-devel
BuildRequires: libbonobo-devel
BuildRequires: libbonoboui-devel
BuildRequires: libcap-devel
BuildRequires: libgnome-devel
BuildRequires: libgnomecanvas-devel
BuildRequires: libgnomeui-devel
BuildRequires: libjpeg-devel
BuildRequires: libpng-devel
BuildRequires: libselinux-devel
BuildRequires: libxcb-devel
BuildRequires: libxml2-devel
BuildRequires: mesa-libGL-devel
BuildRequires: mesa-libGLU-devel
BuildRequires: nspr-devel
BuildRequires: nss-devel
BuildRequires: openssl-devel
BuildRequires: pango-devel
BuildRequires: pixman-devel
BuildRequires: popt-devel
BuildRequires: sqlite-devel
BuildRequires: xcb-util-devel
BuildRequires: xulrunner-devel >= %{geckover}
BuildRequires: zlib-devel
Requires: java >= 1.6.0
Requires: gtk2

Obsoletes: libswt3-gtk2
Obsoletes: eclipse-rcp
Obsoletes: eclipse-cvs-client
Obsoletes: eclipse-platform
Obsoletes: eclipse-jdt
Obsoletes: eclipse-pde
Obsoletes: eclipse-pde-runtime
Obsoletes: eclipse-cdt
Obsoletes: eclipse-cdt-sdk
Obsoletes: eclipse-changelog
Obsoletes: eclipse-rpm-editor

%description
Eclipse is an open extensible IDE for anything and nothing in particular.

%prep
rm -rf eclipse
mkdir eclipse
cd eclipse
unzip -qo %{SOURCE0}

%patch0 -p0 -b .osgi~

pushd "plugins/org.eclipse.swt/Eclipse SWT PI/gtk/library"
%patch10 -p3
popd
pushd plugins/org.eclipse.swt
%patch11
popd

sed -e 's,@@ECLIPSE_DIR@@,%{eclipse_dir},g' %{SOURCE1000} > eclipse.sh
sed -e 's,@@ECLIPSE_DIR@@,%{eclipse_dir},g' %{SOURCE1001} > eclipserc

%build
cd eclipse
ORIGCLASSPATH=$CLASSPATH

# Bootstrapping:
# 1. Build ecj with javac
ant -DcompilerArg="-encoding ISO-8859-1 -nowarn" -buildfile jdtcoresrc/compilejdtcorewithjavac.xml

# 2. Use this ecj to rebuild itself
export CLASSPATH=`pwd`/jdtcoresrc/ecj.jar:$ORIGCLASSPATH
ant -DcompilerArg="-encoding ISO-8859-1 -nowarn" -buildfile jdtcoresrc/compilejdtcore.xml

# Build the rest of Eclipse
export CLASSPATH=`pwd`/ecj.jar:$ORIGCLASSPATH
export JAVA_HOME=%{java_home}
ant \
  -Dnobootstrap=true \
  -DinstallOs=linux -DinstallWs=gtk -DinstallArch=%{targetarch} \
  -Dlibsconfig=true \
  -DJavaSE-1.6=%{java_home}/jre/lib/rt.jar \
  -DcompilerArg="-encoding ISO-8859-1 -nowarn"

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{eclipse_dir}
mkdir -p %{buildroot}%{_datadir}/applications
mkdir -p %{buildroot}%{_datadir}/pixmaps

cd eclipse/result
tar xzf linux-gtk-%{targetarch}-sdk.tar.gz

cd eclipse
unzip -q %{SOURCE1}
tar cf - .eclipseproduct configuration eclipse eclipse.ini \
  features icon.xpm libcairo-swt.so plugins \
  | tar xf - -C %{buildroot}%{eclipse_dir}

install -m 0755 ../../eclipse.sh %{buildroot}%{_bindir}/eclipse
install -m 0644 ../../eclipserc %{buildroot}%{eclipse_dir}/eclipserc
install -m 0644 %{SOURCE1002} %{buildroot}%{_datadir}/applications/eclipse.desktop
install -d -m 0755 %{buildroot}%{eclipse_dir}/links

# link icon
mkdir -p %{buildroot}%{_datadir}/pixmaps
ln -s ../../..%{eclipse_dir}/icon.xpm %{buildroot}%{_datadir}/pixmaps/eclipse.xpm

%clean
rm -rf %{buildroot}
 
%files
%defattr(-,root,root)
%doc eclipse/result/eclipse/epl-v10.html
%doc eclipse/result/eclipse/about.html
%doc eclipse/result/eclipse/readme/readme_eclipse.html
%doc eclipse/result/eclipse/notice.html
%doc eclipse/result/eclipse/readme/readme_pleiades.txt
%doc eclipse/result/eclipse/readme/readme_pleiades_changes.txt
%{_bindir}/eclipse
%{eclipse_dir}
%{_datadir}/applications/eclipse.desktop
%{_datadir}/pixmaps/eclipse.xpm

%changelog
* Sun Jul  5 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.4.2-7m)
- apply Patch10,11 for xulrunner-1.9.1 from Fedora 11 (1:3.4.2-12)

* Sat Jun 20 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.4.2-6m)
- rebuild against xulrunner-1.9.1

* Sun May 10 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (3.4.2-5m)
- switch to use %%{java_home}

* Wed May  6 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.4.2-4m)
- Obsoletes: eclipse-pde-runtime

* Wed May  6 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.4.2-3m)
- add Obsoletes to kill Fedora Eclipse

* Wed May  6 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.4.2-2m)
- add BuildRequires and Requires

* Tue May  5 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.4.2-1m)
- update to 3.4.2
-- back to momonga style
-- use pleiades

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.2-5m)
- rebuild against gcc43

* Wed Feb 13 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (3.2.2-4m)
- %%NoSource -> NoSource

* Mon May  7 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.2.2-3m)
- update eclipse3.desktop and link icon

* Mon May  7 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (3.2.2-2m)
- support gcj
- Obsoletes: ecj-compat

* Wed Feb 21 2007 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.2.2-1m)
- update to 3.2.2

* Wed Oct  4 2006 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.2.1-1m)
- update to 3.2.1

* Fri Aug 18 2006 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.2-1m)
- update to 3.2
  add Patch0: eclipse3-set-javac-properties.patch

* Thu Jun 29 2006 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.1.2-2m)
- enable x86_64

* Wed Jun 28 2006 Nakamura Hirotaka <h_nakamura@momonga-linux.org>
- (3.1.2-1m)
- version 3.1.2
- to main

* Fri Dec  2 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (3.1.1-1m)
- version 3.1.1
- add language packs.

* Sun Aug 21 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (3.1-1m)
- up to 3.1
- BuildPreReq: java-sun-j2se1.5-sdk

* Sat Oct 23 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (3.0.1-3m)
- build eclipse from source

* Mon Sep 27 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (3.0.1-2m)
- added 'export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:/usr/lib"' to eclipse3.sh.in
  in order to be loaded libjavahl-1.so by subclipse plugin
  If adding /usr/lib to LD_LIBRARY_PATH is not good for security,
  we should move libjavahl-1.so* to the isolated directory.

* Sun Sep 26 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (3.0.1-1m)
- 
